## Better style:
## 1- use lists and dictionaries to group data together
## 2- use functions to make your code more readable

from medialib import *
from random import *

## This is what I want to do:
##  Draw 1 rectangle,
##  wait a bit
##  then the rectangle grows a bit larger
##  wait a bit
##  then the rectangle grows a bit larger
##  ...
##  when the rectangle is very large, make it small again
##  wait a bit
##  then the rectangle grows a bit larger
##  ...
##
## When the user presses the mouse button, the animation stops

initialize()

is_running = True

clear(100,0,0)
counter = 0
while is_running:
    counter = counter + 1

    clear()
    ## external, white rectangle
    rect(400-counter/2,300-counter/2,
            10+counter,10+counter)
    ## internal, background-color rectangle
    rect(400-counter/2+5,300-counter/2+5,
            10+counter-10,10+counter-10,
            100,0,0)
    
    if counter>100:
        counter = 0

    if is_mouse_press():
        is_running = False

    ## slow down the animation
    wait(0.050)

all_done()
