## Better style:
## 1- use lists and dictionaries to group data together
## 2- use functions to make your code more readable

from medialib import *
from random import *

## Now: like before, but 10 differnt rectangles
##      placed randomly around the screen,
##      and the each rectangle has a different color
##
## It is BETTER at this point to stop and re-structure the code,
## using variables to remember where the rectangles are, and which colors they have
## and perhaps use functions to draw and make them grow too...
##
## The code will look much nicer, more readable, and shorter, after this re-structuring!
##

initialize()

rectangles = []

def initialize_rectangles(rect_list,how_many):
    for i in range(0,how_many):
        rectangle = { 'x': randint(10,70)*10,
                      'y': randint(10,50)*10,
                      'red': randint(1,25)*10,
                      'green': randint(1,25)*10,
                      'blue': randint(1,25)*10
                    }
        rectangles.append( rectangle )

def draw_rectangles(the_list,c):
    for r in the_list:
        ## for debugging only: print( r )
        rect(r['x']-c/2,r['y']-c/2,
            10+c,10+c,
            r['red'],r['green'],r['blue'])
        rect(r['x']-c/2 +5,r['y']-c/2 +5,
            c,c,
            100,0,0)

initialize_rectangles(rectangles,10)
is_running = True

clear(100,0,0)
counter = 0
while is_running:
    counter = counter + 1

    clear()
    draw_rectangles(rectangles,counter)
   
    if counter>100:
        counter = 0

    if is_mouse_press():
        is_running = False

    ## slow down the animation
    wait(0.050)

all_done()
