## Better style:
## 1- use lists and dictionaries to group data together
## 2- use functions to make your code more readable

from medialib import *
from random import *

## Now: like before, but now each rectangle grows at a random speed... 
## 
## Notice how the program is now divide in two:
## - definition of data and functions
## - a shorter and more readable program that uses the functions

initialize()

rectangles = []

def initialize_rectangles(rect_list,how_many):
    for i in range(0,how_many):
        rectangle = { 'x': randint(10,70)*10,
                      'y': randint(10,50)*10,
                      'red': randint(1,25)*10,
                      'green': randint(1,25)*10,
                      'blue': randint(1,25)*10,
                      'size': 1,
                      'growing_speed': random()*3
                    }
        rectangles.append( rectangle )

def grow_rectangles(the_list):
    for index in range(0,len(the_list)):
        a = the_list[index]['size']
        a = a + the_list[index]['growing_speed']
        if a>100:
            a = 0
        the_list[index]['size'] = a


def draw_rectangles(the_list):
    for r in the_list:
        c = r['size']
        rect(r['x']-c/2,r['y']-c/2,
            10+c,10+c,
            r['red'],r['green'],r['blue'])
        rect(r['x']-c/2 +5,r['y']-c/2 +5,
            c,c,
            100,0,0)



initialize_rectangles(rectangles,10)
is_running = True

clear(100,0,0)
while is_running:
    grow_rectangles(rectangles)

    clear()
    draw_rectangles(rectangles)
   
    if is_mouse_press():
        is_running = False

    ## slow down the animation
    wait(0.050)

all_done()
