## Example of "Top-Down problem analysis"
##
## The game of rock-paper-scissors has the following steps:
## 1- the computer randomly makes a move
## 2- the player inputs his/her move
## 3- the computer shows both moves
## 4- then the computer evaluates the 2 moves and decides who won
##
from random import *

## -------------------------------------------------------------
## Fine, now we need to implement the decide_who_won() function!
## -------------------------------------------------------------

def compute_random_move():
	choice = 'nothing'	
	computer_move = randint(1,3)
	if computer_move==1:
		choice = "paper"
	if computer_move==2:
		choice = "rock"
	if computer_move==3:
		choice = "scissors"	
	return choice ## this is right now!

def player_input_move():
	print('+-----------------------------+')
	print('| Enter:                      |')
	print('|   p     to choose PAPER     |')
	print('|   r     to choose ROCK      |')
	print('|   s     to choose SCISSORS  |')	
	print('+-----------------------------+')
	your_input = input('Enter your choice, then press ENTER: ')

	if your_input=='p':
		your_choice = "paper"
	if your_input=='r':
		your_choice = "rock"
	if your_input=='s':
		your_choice = "scissors"
	return your_choice

def show_both_moves():
	print('\n\nyou: %s , and the computer: %s' % (user_choice,computer_choice) )
	print('\n\n')

## (done!)
def decide_who_won():
	result = 'nothing'
	explanation = 'whatever'

	if user_choice==computer_choice: ## tie
		result = 'tie'
		explanation = 'both moves are the same'

	elif user_choice=='paper':
		if computer_choice=='rock': ## human wins
			result = 'human wins'
			explanation = 'paper wraps rock'
		else: ## computer_choice must be "scissors": computer wins
			result = 'computer wins'
			explanation = 'scissors cut paper'

	elif user_choice=='rock':
		if computer_choice=='scissors': ## human wins
			result = 'human wins'
			explanation = 'rock blunts scissors'
		else: ## computer_choice must be "paper": computer wins
			result = 'computer wins'
			explanation = 'paper wraps rock'

	elif user_choice=='scissors':
		if computer_choice=='paper': ## human wins
			result = 'human wins'
			explanation = 'scissors cut paper'
		else: ## computer_choice must be "rock": computer wins
			result = 'computer wins'
			explanation = 'rock blunts scissors'

	print('And the result is: *%s*!\n...because %s.\n\n' % (result,explanation) )



computer_choice = compute_random_move()
user_choice = player_input_move()
show_both_moves()
decide_who_won()

input('Press the ENTER key to exit.')

############################################################
##
## Game completed and working!
##
############################################################