## A simple game - "rock paper scissors"
## the computer randomly makes a move in the game of RPS
## the player inputs her move, for example by clicking on the image of the move she wants to do
## the computer shows both moves
## then the computer evaluates the 2 moves and decides who won
#############################################################################
## images are taken from https://en.wikipedia.org/wiki/Rock_paper_scissors
##
from medialib import *
from random import *

initialize()

## the computer randomly makes a move in the game of RPS
computer_move = randint(1,3)
if computer_move==1:
	computer_choice = "paper"
if computer_move==2:
	computer_choice = "rock"
if computer_move==3:
	computer_choice = "scissors"
## DEBUG print(computer_move)

## the player inputs her move, for example by clicking on the image of the move she wants to do
clear()
draw("150px-Rock-paper-scissors_(paper).png",100,100)
draw("150px-Rock-paper-scissors_(rock).png",100+250,100)
draw("150px-Rock-paper-scissors_(scissors).png",100+250*2,100)

text("click on your choice...",50,10,16)
wait_mouse_leftclick()
mouse_x,mouse_y = get_mouse_pos()
print(mouse_x,mouse_y)

user_choice = "nothing"
if point_inside_rect(mouse_x,mouse_y, 100,100,150,150):
	user_choice = "paper"
if point_inside_rect(mouse_x,mouse_y, 100+250,100,150,150):
	user_choice = "rock"
if point_inside_rect(mouse_x,mouse_y, 100+250*2,100,150,150):
	user_choice = "scissors"

## nothing was selectec, try again
while user_choice=="nothing":
	wait_mouse_leftclick()
	mouse_x,mouse_y = get_mouse_pos()
	print(mouse_x,mouse_y)

	user_choice = "nothing"
	if point_inside_rect(mouse_x,mouse_y, 100,100,150,150):
		user_choice = "paper"
	if point_inside_rect(mouse_x,mouse_y, 100+250,100,150,150):
		user_choice = "rock"
	if point_inside_rect(mouse_x,mouse_y, 100+250*2,100,150,150):
		user_choice = "scissors"

## the computer shows both moves
clear()
print( "your clicked on " + user_choice )
text("your clicked on " + user_choice,50,10,16)
if user_choice=="paper":
	draw("150px-Rock-paper-scissors_(paper).png",100,100)
if user_choice=="rock":
	draw("150px-Rock-paper-scissors_(rock).png",100+250,100)
if user_choice=="scissors":
	draw("150px-Rock-paper-scissors_(scissors).png",100+250*2,100)

if computer_choice=="paper":
	draw("150px-Rock-paper-scissors_(paper)_computer.png",100,400)
if computer_choice=="rock":
	draw("150px-Rock-paper-scissors_(rock)_computer.png",100+250,400)
if computer_choice=="scissors":
	draw("150px-Rock-paper-scissors_(scissors)_computer.png",100+250*2,400)

## then the computer evaluates the 2 moves and decides who won
if user_choice==computer_choice: ## tie
	draw("tie.png",100+250,300)
elif user_choice=="paper":
	if computer_choice=="rock": ## human wins
		draw("human_wins.png",100+250,300)
	else: ## computer_choice must be "scissors": ## computer wins
		draw("computer_wins.png",100+250,300)
elif user_choice=="rock":
	if computer_choice=="scissors": ## human wins
		draw("human_wins.png",100+250,300)
	else: ## computer_choice must be "paper": ## computer wins
		draw("computer_wins.png",100+250,300)
elif user_choice=="scissors":
	if computer_choice=="paper": ## human wins
		draw("human_wins.png",100+250,300)
	else: ## computer_choice must be "rock": ## computer wins
		draw("computer_wins.png",100+250,300)

text("Left-click the mouse to exit.",50,550,16)
wait_mouse_leftclick()

all_done()

#############################################################################
##
## The code above works, but ...
## - it is long and complex to read, with repetitions, therefore
## - it is difficult to modify, debug
##
#######################################################################################
## TASK: implement the "cleaner" version of game, use functions for example...
#######################################################################################
