## Procedurally generated Pong game
## (procedural because no images are used)
##
## original Pong https://en.wikipedia.org/wiki/Pong

from medialib import *
from random import *
initialize()

## prepare rectangles for the background
rectangles = []
for i in range(0,20):
    r = [randint(0,700),randint(0,500),
         randint(0,200),randint(0,200),
         randint(2,15)*10]
    rectangles.append( r )

print('PONG version 2')
print('==============')
print('Move the mouse up and down to play')
print('   and press mouse button to quit')


## game state
game_running = True
paddle_y = 200
ball_pos = [10,10]
ball_speed = [+12,+12]

clear(75,0,130)
while game_running:

    ## draw the game state
    clear()

    ## draw background rectangles
    for rectangle in rectangles:
        x,y,w,h,green = rectangle
        a = randint(-4,4)
        b = randint(-3,3)
        x-=a/2
        y-=b/2
        w+=a
        h+=b
        rect(x,y,w,h, 0,green,0)

    rect(ball_pos[0]-5,ball_pos[1]-5,
            10,10,
            255,0,0) #red
    rect(700,paddle_y-20,10,40) ## fixed X pos at 700pixels

    ## update game state
    ball_pos[0] += ball_speed[0]
    ball_pos[1] += ball_speed[1]

    x,y = get_mouse_pos()
    paddle_y = y

    ## collision with screen borders
    if (ball_pos[0]>800-10) or (ball_pos[0]<0+10):
        ## horizontal collision
        ball_speed[0] = -ball_speed[0]
        ball_pos[0] += ball_speed[0]
        play('pong_bounce1.mp3')

    if (ball_pos[1]>600-10) or (ball_pos[1]<0+10):
        ## vertical collision
        ball_speed[1] = -ball_speed[1]
        ball_pos[1] += ball_speed[1]
        play('pong_bounce1.mp3')

    if (ball_pos[1]>=paddle_y-20) and (ball_pos[1]<paddle_y+20) and \
        (ball_pos[0]>=700) and (ball_pos[0]<=710):
        ## bounce off the paddle
        ball_speed[0] = -ball_speed[0]
        ball_pos[0] += ball_speed[0]
        play('pong_bounce2.mp3')

    ## check and react to input
    if is_mouse_press():
        game_running = False

    ## slow down the game, to be more playable
    wait(0.050)

all_done()

## free sound, source:
## https://freesound.org/people/TyroneW/sounds/326433/
