from csv import *
from medialib import *
initialize()

##################################################################
# 1. load all data from the CSV file, and convert it into a list
##################################################################
csv_file = open('movies_data.csv','r') # opening in read-mode
file_reader = reader(csv_file)
data = list(file_reader)             # the list!!
print(data[0]) # the first row


###############################################################################
# 2. use a FOR LOOP to look at the data and calculate various statistical data
###############################################################################

scarlett_counter = 0
hemsworth_counter = 0
average_rating = 0
for index in range(1,len(data)):
    if "Scarlett Johansson" in data[index][4]: # in the actors list
        scarlett_counter = scarlett_counter + 1
    if "Chris Hemsworth" in data[index][4]: # in the actors list
        hemsworth_counter = hemsworth_counter + 1

    rating = float( data[index][8].split('/')[0] )
    average_rating = average_rating + rating

average_rating = average_rating / (len(data)-1)

###############################################################################
# 3. use a FOR LOOP to look at the data and calculate various statistical data
###############################################################################

# use a for loop do draw a bar chart
clear()
for index in range(1,len(data)): # skip the first row, because it's only headers

    y = index*16
    text( data[index][0] ,10,y,14) ## title
    
    rating = float( data[index][8].split('/')[0] )
    text( str(rating) ,200,y,14) ## rating

    ## visualize the genres
    if "Action" in data[index][2]:
        rect(250,y, 8,8,  0,255,0) # green
    if "Adventure" in data[index][2]:
        rect(260,y, 8,8,  255,255,0) # yellow
    if "Sci-Fi" in data[index][2]:
        rect(270,y, 8,8,  255,0,0) # red
    if "Fantasy" in data[index][2]:
        rect(270,y, 8,8,  0,0,255) # blue

    ## is there Gwyneth Paltrow among the actors?
    if "Gwyneth Paltrow" in data[index][4]:
        text("G",280,y,12, 255,105,180) # pink

    ## is there Chris Hemsworth among the actors?
    if "Chris Hemsworth" in data[index][4]:
        draw("images/Chris Hemsworth.png",300,y)

## word-cloud with names of some actors
text("Scarlett",600,10,scarlett_counter*10)
text("Hemsworth",600,70,hemsworth_counter*10)

## display the average rating of all movies in the data
rect(600-5,150-5, 70,50, 90,90,90)  # gray
if average_rating>6:
    rect(600-5,150-5, 70,50, 0,180,0) # green
if average_rating>7.5:
    rect(600-5,150-5, 70,50, 255,215,0) # gold
text("Avg R",600,150,16)
text(str(average_rating),600,170,16)

#########################################################
text("Click to finish",300,580,16)
wait_mouse_leftclick()
all_done() # always the last instruction of the program
